package cn.iocoder.yudao.module.mes.service.record;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.mes.controller.admin.record.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.record.RecordTemplateDO;
import cn.iocoder.yudao.module.mes.dal.mysql.record.RecordTemplateMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link RecordTemplateServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(RecordTemplateServiceImpl.class)
public class RecordTemplateServiceImplTest extends BaseDbUnitTest {

    @Resource
    private RecordTemplateServiceImpl recordTemplateService;

    @Resource
    private RecordTemplateMapper recordTemplateMapper;

    @Test
    public void testCreateRecordTemplate_success() {
        // 准备参数
        RecordTemplateSaveReqVO createReqVO = randomPojo(RecordTemplateSaveReqVO.class).setId(null);

        // 调用
        Long recordTemplateId = recordTemplateService.createRecordTemplate(createReqVO);
        // 断言
        assertNotNull(recordTemplateId);
        // 校验记录的属性是否正确
        RecordTemplateDO recordTemplate = recordTemplateMapper.selectById(recordTemplateId);
        assertPojoEquals(createReqVO, recordTemplate, "id");
    }

    @Test
    public void testUpdateRecordTemplate_success() {
        // mock 数据
        RecordTemplateDO dbRecordTemplate = randomPojo(RecordTemplateDO.class);
        recordTemplateMapper.insert(dbRecordTemplate);// @Sql: 先插入出一条存在的数据
        // 准备参数
        RecordTemplateSaveReqVO updateReqVO = randomPojo(RecordTemplateSaveReqVO.class, o -> {
            o.setId(dbRecordTemplate.getId()); // 设置更新的 ID
        });

        // 调用
        recordTemplateService.updateRecordTemplate(updateReqVO);
        // 校验是否更新正确
        RecordTemplateDO recordTemplate = recordTemplateMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, recordTemplate);
    }

    @Test
    public void testUpdateRecordTemplate_notExists() {
        // 准备参数
        RecordTemplateSaveReqVO updateReqVO = randomPojo(RecordTemplateSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> recordTemplateService.updateRecordTemplate(updateReqVO), RECORD_TEMPLATE_NOT_EXISTS);
    }

    @Test
    public void testDeleteRecordTemplate_success() {
        // mock 数据
        RecordTemplateDO dbRecordTemplate = randomPojo(RecordTemplateDO.class);
        recordTemplateMapper.insert(dbRecordTemplate);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbRecordTemplate.getId();

        // 调用
        recordTemplateService.deleteRecordTemplate(id);
       // 校验数据不存在了
       assertNull(recordTemplateMapper.selectById(id));
    }

    @Test
    public void testDeleteRecordTemplate_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> recordTemplateService.deleteRecordTemplate(id), RECORD_TEMPLATE_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetRecordTemplatePage() {
       // mock 数据
       RecordTemplateDO dbRecordTemplate = randomPojo(RecordTemplateDO.class, o -> { // 等会查询到
           o.setName(null);
           o.setOrganizationId(null);
           o.setMachineId(null);
           o.setWorkTeamId(null);
           o.setStartTime(null);
           o.setEndTime(null);
           o.setGroupManagerApproveId1(null);
           o.setGroupManagerApproveId2(null);
           o.setProductionManagerApproveId1(null);
           o.setProductionManagerApproveId2(null);
           o.setProcessInstanceId(null);
           o.setStatus(null);
           o.setRecordType(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       recordTemplateMapper.insert(dbRecordTemplate);
       // 测试 name 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setName(null)));
       // 测试 organizationId 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setOrganizationId(null)));
       // 测试 machineId 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setMachineId(null)));
       // 测试 workTeamId 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setWorkTeamId(null)));
       // 测试 startTime 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setStartTime(null)));
       // 测试 endTime 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setEndTime(null)));
       // 测试 groupManagerApproveId1 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setGroupManagerApproveId1(null)));
       // 测试 groupManagerApproveId2 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setGroupManagerApproveId2(null)));
       // 测试 productionManagerApproveId1 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setProductionManagerApproveId1(null)));
       // 测试 productionManagerApproveId2 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setProductionManagerApproveId2(null)));
       // 测试 processInstanceId 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setProcessInstanceId(null)));
       // 测试 status 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setStatus(null)));
       // 测试 recordType 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setRecordType(null)));
       // 测试 remark 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       recordTemplateMapper.insert(cloneIgnoreId(dbRecordTemplate, o -> o.setCreateTime(null)));
       // 准备参数
       RecordTemplatePageReqVO reqVO = new RecordTemplatePageReqVO();
       reqVO.setName(null);
       reqVO.setOrganizationId(null);
       reqVO.setMachineId(null);
       reqVO.setWorkTeamId(null);
       reqVO.setStartTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));
       reqVO.setEndTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));
       reqVO.setGroupManagerApproveId1(null);
       reqVO.setGroupManagerApproveId2(null);
       reqVO.setProductionManagerApproveId1(null);
       reqVO.setProductionManagerApproveId2(null);
       reqVO.setProcessInstanceId(null);
       reqVO.setStatus(null);
       reqVO.setRecordType(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<RecordTemplateDO> pageResult = recordTemplateService.getRecordTemplatePage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbRecordTemplate, pageResult.getList().get(0));
    }

}